<?php
namespace Home\Controller;
use Think\Controller;
/*
* 广告控制器
*
*/
class AdController extends BaseController
{

    //广告列表
    public function adList()
    {   
        $type = I('type');
        //file_put_contents('/opt/logs/ylc.llewan.com/ylc.log',json_encode($_REQUEST));
        if(empty($type)) {
            $result = array(
                'c'=>2
                ,'msg'=>'type参数不存在'
            );
        } else {
            $redis = S(C('REDIS'));
            $id = $redis->ZRANGE('ylc_ad_id',0,-1);
            foreach($id as $key=>$val) {
                $arr = json_decode($redis->hget('ylc_ad_list',$val),true);
                $startTime = $arr['start_time'] < date('Y-m-d H:i:s');
                $endTime = $arr['end_time'] == null || $arr['end_time'] > date('Y-m-d H:i:s');

                if($arr['status'] == 1 && $arr['type'] == $type && $startTime && $endTime) {
                    $adArr[]  = array(
                        'id'=>$arr['sysid']
                        ,'platform'=>$arr['platform']
                        ,'name'=>$arr['name']
                        ,'img'=>$arr['img']
                        ,'appid'=>$arr['appid']
                        ,'gourl'=>$arr['gourl']
                        ,'position'=>$arr['position']
                        ,'type'=>$arr['type']
                    );
                }
            }

            // $whereArr = array(
            //     'type'=>$type
            //     ,'status'=>1
            //     ,'start_time'=>array('lt',date('Y-m-d H:i:s'))
            // );
            // $whereArr['_string'] = 'end_time is null or end_time > "'.date('Y-m-d H:i:s').'"';
            // $field = 'sysid as id,platform,name,img,appid,gourl,position,type';
            // $adArr = M("yl_ad","",C("LEWAN_HEZI"))->where($whereArr)->field($field)->order('position')->select();
            if(!empty($adArr)) {
                $result = array(
                    'c'=>1
                    ,'msg'=>'获取成功'
                    ,'d'=>array(
                        'list'=>$adArr
                    )
                );

            } else {
                $result = array(
                    'c'=>2
                    ,'msg'=>'暂无数据'
                );
            }

        }
        echo $this->formatRes($result);
    }

}

?>