<?php
namespace Home\Controller;
use Think\Controller;
/*
* 进入应用控制器
*
*/
class EntryController extends BaseController
{

    //用户进入
    public function userEntry()
    {   
        $token = decryptToken(I('token'));

        if($token == false) {
            $result = array(
                'c'=>2
                ,'msg'=>'token不正确'
            );
        } else {
            $uid = $token['uid'];
            // $uid = 97335894;
            $requestData = I('request.');
            $userModel= new \Home\Model\UserModel();

            //邀请新用户任务
            if(!empty($requestData['reid'])) {
                $reWhere = array(
                    'uid'=>$uid
                    ,'referee_id'=>$requestData['reid']
                    ,'reg_time'=>array('gt',(time()-90))
                );
                $userInfo = M("game_member","",C("LEWAN_HEZI"))->where($reWhere)->find();
                if(!empty($userInfo)) {
                    $result = $userModel->inviteTask($uid,$requestData['reid']);
                }
            }

            //竞拍用户邀请添加出价次数
            if(!empty($requestData['auction_id']) && $uid != $requestData["reid"]) {
                //查询用户邀请记录
                $auctionWhere = array(
                    'uid'=>$uid
                    ,'game_code'=>'zuiqiangyoulechang'
                    ,'invite_user'=>$requestData["reid"]
                    ,'source'=>$requestData["auction_id"]
                );
                $auctionNum = M("game_member_invite","",C("LEWAN_HEZI"))->where($auctionWhere)->count();
                if($auctionNum < 1) {
                    $result = $userModel->auctionInvite($uid,$requestData['reid'],$requestData["auction_id"]);
                }
            }
            // if(!empty($requestData['auction_id'])) {
            //     $result = $userModel->auctionInvite($uid,$requestData['reid'],$requestData["auction_id"]);
            // }

        }
        echo $this->formatRes($result);
    }

	//保存模板消息formid
	public function templateFormid(){
		$token = decryptToken(I('token'));
		$formid = I('formid');

		if($token == false) {
            $result = array(
                'c'=>2
                ,'msg'=>'token不正确'
			);
			echo $this->formatRes($result);exit;
		} else if(empty($formid)) {
            $result = array(
                'c'=>2
                ,'msg'=>'formid参数不存在'
			);
			echo $this->formatRes($result);exit;
        }
        $uid = $token['uid'];

        //获取用户昵称
        $userArr = M("game_member","",C("LEWAN_HEZI"))->where(array('uid'=>$uid))->field('user_nickname')->find();

        $addArr = array(
            'uid'=>$uid
            ,'openid'=>$token['openid']
            ,'nick_name'=>$userArr['user_nickname']
            ,'form_id'=>$formid
            ,'add_time'=>date('Y-m-d H:i:s')
        );

        //保存模板消息formid
        M("yl_template_formid","",C("LEWAN_HEZI"))->add($addArr);
        $result = array(
            'c'=>1
            ,'msg'=>'保存成功'
        );

		echo $this->formatRes($result);exit;
	}

}

?>