<?php
namespace Home\Controller;
use Think\Controller;
/*
* 刷新redis数据控制器
*
*/
class FlushController extends BaseController
{

    //刷新广告数据
    public function ad()
    {   
        $adArr = M("yl_ad","",C("LEWAN_HEZI"))->order('position')->select();
        if(!empty($adArr)) {
            $redis = S(C('REDIS'));
            foreach($adArr as $key=>$val) {
                //保存广告id（用于排序分页）
                $redis->zadd('ylc_ad_id',$val['position'],$val['sysid']);
                //保存广告数据
                $redis->hset('ylc_ad_list',$val['sysid'],json_encode($val));
            }
            exit('更新成功');
        } else {
            exit('暂无数据');
        }

    }


    //刷新游戏数据
    public function game($game='zuiqiangyoulechang',$skip=0,$limit=10)
    {   
        $gameList = M("yl_game","",C("LEWAN_HEZI"))->where(['game_code'=>$game])->select();
        if(!empty($gameList)) {
            $redis = S(C('REDIS'));
            foreach($gameList as $key=>$val) {
                $gameList[$key]['typeList'] = M("yl_game_class","",C("LEWAN_HEZI"))->join('left join yl_game_class_list on yl_game_class.sysid=yl_game_class_list.r_class')->where(array('yl_game_class_list.r_game'=>$val['sysid']))->field('yl_game_class_list.r_class,yl_game_class_list.r_game,yl_game_class.name')->select();
                $gameList[$key]['labelList'] = M("yl_game_label","",C("LEWAN_HEZI"))->join('left join yl_game_label_list on yl_game_label.sysid=yl_game_label_list.r_label')->where(array('yl_game_label_list.r_game'=>$val['sysid']))->field('yl_game_label_list.r_label,yl_game_label_list.r_game,yl_game_label.name')->select();
                //保存游戏id（用于排序分页）
                $redis->zadd($game.'_game_id',$val['sort'],$val['sysid']);
                //保存游戏数据
                $redis->hset($game.'_game_list',$val['sysid'],json_encode($gameList[$key]));
            }
            // exit('更新成功');
            return $redis->ZREVRANGE($game.'_game_id',$skip,$limit);
        } else {
            exit(json_encode(array('c'=>2,'msg'=>'暂无数据')));
        }

    }


    //刷新商品数据
    public function goods()
    {   
        $goodsList = M("yl_goods","",C("LEWAN_HEZI"))->select();
        if(!empty($goodsList)) {
            $redis = S(C('REDIS'));
            foreach($goodsList as $key=>$val) {
                //保存游戏id（用于排序分页）
                $redis->zadd('ylc_goods_id',$val['sort'],$val['sysid']);
                //保存游戏数据
                $redis->hset('ylc_goods_list',$val['sysid'],json_encode($val));
            }
            exit('更新成功');
        } else {
            exit('暂无数据');
        }

    }

    public function cdnUrl() {
        $refreshURL = I("url");
        // $refreshURL = "https://res.g.llewan.com/uploadfile/common/qubapikashu-weixin/1.0.1/monsterData.json";
        $url	= "https://cdn.api.qcloud.com/v2/index.php?";
        $params['Action']		= "RefreshCdnUrl";
        $params['Nonce']		= rand(1000000000, 9999999999);
        $params['SecretId'] 	= "AKIDghFh1BTzd5Njz4gtfHiy7B8veCZlucIo";
        $params['Timestamp'] 	= time();
        $params['urls.0']		= $refreshURL;

        $secretKey = "ZzEJLPOH4mOGKbxGSUTHuMcidMwLZcT9";
        $origin = "POSTcdn.api.qcloud.com/v2/index.php?Action=RefreshCdnUrl&Nonce={$params['Nonce']}&SecretId={$params['SecretId']}&Timestamp={$params['Timestamp']}&urls.0={$refreshURL}";
        $origin = str_replace('_', '.', $origin);
        $signStr = base64_encode(hash_hmac('sha1', $origin, $secretKey, true));
        $params['Signature']	= $signStr;


        echo curlPost($url,$params);exit;


        $cdnRefreshURL = $url . http_build_query($params);
        $result = file_get_contents($cdnRefreshURL);
        echo($result);
    }

    public function testId() {
            //连接本地的 Redis 服务
        $redis = S(C('REDIS'));
    
    
    
        while($redis->setnx('test_lock', getTime()+100)==0) {
            if(getTime()>$redis->get('test_lock') && getTime()>$redis->getset('test_lock', getTime()+100)){
                break;
            }else{
                usleep(100000);
            }
        }

        $id = $redis->get('test_id');
        if(empty($id)) {
            $id = 100;
        } else {
            $id++;
        }
        $redis->set('test_id',$id);
        echo $id;

        $redis->del('test_lock');
    }

    public function xcxQrcode() {
        $appid = 'wx62cbdff21c74d69d';
        $secret = '42df86aa686101282378b8f42be23f48';
    
        $url = 'https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid='.$appid.'&secret='.$secret;
        $token = file_get_contents($url);
        $token = json_decode($token,true)['access_token'];


        $send_url 	= "https://api.weixin.qq.com/wxa/getwxacodeunlimit?access_token=".$token;
        $send_url 	= "https://api.weixin.qq.com/cgi-bin/wxaapp/createwxaqrcode?access_token=".$token;
        $send_url 	= "https://api.weixin.qq.com/wxa/getwxacode?access_token=".$token;
        $postArr = array(
            // 'scene'=>'source_id=181818'
            'path'=>'pages/index/index?source_id=2002'
            ,'width'=>'280'
        );

        $re = curlPost( $send_url , json_encode($postArr) );
        file_put_contents('new2002.jpg',$re);

    }

    //发起微信小程序支付参数处理
	public function wechatXcxSign() {
		$data['wxappid'] = 'wxde2c29b8d9349652';
		$data['mch_id'] = '1509771971';
		$data['nonce_str'] = uniqid().mt_rand();
		$data['send_name'] = '测试红包';
		$data['mch_billno'] = '1509771971'.date('Ymd').time();
		$data['total_amount'] = 1;
		$data['total_num'] = 1;
		$data['client_ip'] = '111.230.107.18';
		$data['notify_way'] = 'JSAPI';
		$data['wishing'] = '红包祝福语';
		$data['act_name'] = '活动名称';
		$data['remark'] = '备注';
		$data['re_openid'] = 'oPftV44nnKGy1QBAO67-4To7kvDo';

		$sign = wechatCreateSign($data);

		$textTpl = "<xml>
					   <wxappid><![CDATA[%s]]></wxappid>
					   <mch_id><![CDATA[%s]]></mch_id>				   
					   <nonce_str><![CDATA[%s]]></nonce_str>
					   <send_name><![CDATA[%s]]></send_name>
					   <mch_billno><![CDATA[%s]]></mch_billno>
					   <total_amount><![CDATA[%s]]></total_amount>
					   <total_num><![CDATA[%s]]></total_num>
					   <client_ip><![CDATA[%s]]></client_ip>
					   <notify_way><![CDATA[%s]]></notify_way>
					   <wishing><![CDATA[%s]]></wishing>
					   <act_name><![CDATA[%s]]></act_name>
					   <remark><![CDATA[%s]]></remark>
					   <re_openid><![CDATA[%s]]></re_openid>
					   <sign><![CDATA[%s]]></sign>
					</xml>";
        $resultStr = sprintf($textTpl, $data['appid'], $data['mch_id'], $data['nonce_str'], $data['send_name'], $data['mch_billno'],$data['total_amount'],$data['total_num'],$data['client_ip'],$data['notify_way'],$data['wishing'],$data['act_name'],$data['remark'],$data['re_openid'],$sign);
		$wechatOrder = curlPost('https://api.mch.weixin.qq.com/mmpaymkttransfers/sendminiprogramhb',$resultStr,true);


        var_dump($wechatOrder);exit;

		$orderObj = json_decode(json_encode(simplexml_load_string($wechatOrder, 'SimpleXMLElement', LIBXML_NOCDATA)), true);
        if(!empty($orderObj['prepay_id'])) {
			$payArr = array(
				'appId'=>'wxfaf41889efd69020'
				,'package'=>'prepay_id='.$orderObj['prepay_id']
				,'nonceStr'=>uniqid().mt_rand()
				,'timeStamp'=>time()
				,'signType'=>'MD5'
			);
			$xcxPayArr = array(
				'package'=>'prepay_id='.$orderObj['prepay_id']
				,'nonceStr'=>$payArr['nonceStr']
				,'timeStamp'=>strval($payArr['timeStamp'])
				,'signType'=>'MD5'
				,'paySign'=>$this->wechatCreateSign($payArr)
			);
			return $xcxPayArr;
		}
		return array('description'=>$wechatOrder);
		
    }
    
    public function actionSet() {
        //access_token无效重新获取
        $url = 'https://game.test.llewan.com/config/getToken';
        $token = file_get_contents($url);
        $tokenArr = json_decode($token,true);
        if(!empty($tokenArr['d']['token'])) {
            $actionUrl = 'https://api.weixin.qq.com/marketing/user_action_sets/add?version=v1.0&access_token='.$tokenArr['d']['token'];
            $postData = array(
                'type'=>'WEB'
                ,'name'=>'secodeTest'
                ,'"description"'=>'第二次测试获取数据源ID'
            );
            $setId = curlPost($actionUrl,$postData,true);
            var_dump($setId);

        } else {
            exit(json_encode(array('c'=>2,'msg'=>'获取失败','error'=>$tokenArr['error'])));
        }



    }
    

}

?>