<?php
namespace Home\Controller;
use Think\Controller;
/*
* 微信处理控制器
*
*/
class WechatController extends BaseController
{
    public $appid = 'wx27a7a5c8d80d2cd8';
    public $secret = 'a9dc1534c5985c9ad34d8b6fd3f7b2d5';

    //小程序消息回复
    public function respondMsg()
    {   
        if (isset($_GET['echostr'])) {
            $this->valid();
        }else{
            if($this->checkSignature()) {
                $postStr = file_get_contents("php://input");
                if (!empty($postStr)){
                    $postObj = simplexml_load_string($postStr, 'SimpleXMLElement', LIBXML_NOCDATA);
                    $fromUsername = $postObj->FromUserName;
                    $toUsername = $postObj->ToUserName;
                    $MsgType = $postObj->MsgType;
                    $keyword = trim($postObj->Content);
                    $time = time();
        
                    $token = $this->getToekn();
                    $token = json_decode($token,true)['access_token'];
        
                    $posturl = 'https://api.weixin.qq.com/cgi-bin/message/custom/send?access_token='.$token;
                    /*$data = '{
                                "touser":"'.$fromUsername.'",
                                "msgtype":"text",
                                "text":
                                {
                                     "content":"你好"
                                }
                            }';*/
        
                    $data = '{
                                "touser":"'.$fromUsername.'",
                                "msgtype":"image",
                                "image":
                                {
                                  "media_id":"AsEriSNkp4IZ6vUowg8bViVijbgvqOfbh6N_5r4B_9NLITJOAplkEWVjsz9r3LIp"
                                }
                            }';
        
                    //$data = json_encode($data);
                    $re = $this->curlPost($posturl,$data,true);
        
                }
            } else {
                echo 'bad request';
            }
        }
    }

    //上传临时图片
    public function  uploadMedia() {
        $token = $this->getToekn();
        $token = json_decode($token,true)['access_token'];
        $posturl = 'https://api.weixin.qq.com/cgi-bin/media/upload?type=image&access_token='.$token;

        $obj = new \CURLFile('uploadfile/lw.jpg');
        //var_dump($obj);exit;
        $data = array('media' => $obj);

        //$data = json_encode($data);
        $re = $this->curlPost($posturl,$data,true);
        var_dump($re);
    }


    //每日签到提醒
    public function signTips() {
        set_time_limit(0);
        $signWhere = array(
            'game_code'=>'zuiqiangyoulechang'
            ,'add_time'=>array('gt',strtotime(date('Y-m-d')))
        );
        $signArr = M("game_member_sign","",C("LEWAN_HEZI"))->where($signWhere)->field('uid')->select();
        if(!empty($signArr)) {
            $signArr = array_column($signArr,'uid');
        }

        $sendWhere = array(
            'use_way'=>'sign_tips'
            ,'send_time'=>array('gt',date('Y-m-d'))
        );
        $sendArr = M("yl_template_formid","",C("LEWAN_HEZI"))->where($sendWhere)->field('uid')->select();
        if(!empty($sendArr)) {
            $sendArr = array_column($sendArr,'uid');
        }

        $removeArr = array_merge($signArr,$sendArr);

        $msgWhere = array(
            'status'=>'1'
            ,'add_time'=>array('gt',date('Y-m-d',time()-(60*60*24*6)))
            // ,'uid'=>array('not in',$removeArr)
        );
        if(!empty($removeArr)) {
            $msgWhere['uid'] = array('not in',$removeArr);
        }
        $msgArr = M("yl_template_formid","",C("LEWAN_HEZI"))->where($msgWhere)->group('openid')->order('add_time')->limit(200)->select();

        if(!empty($msgArr)) {
            $token = $this->getToekn();
            $token = json_decode($token,true)['access_token'];
            foreach($msgArr as $key=>$val) {
                $usergisnArr = array(
                    'uid'=>$val['uid']
                    ,'game_code'=>'zuiqiangyoulechang'
                );
                $usergisnArr['add_time'][] = array('gt',strtotime(date('Y-m-d',time()-(60*60*24))));
                $usergisnArr['add_time'][] = array('lt',strtotime(date('Y-m-d')));
                $usergisnInfo = M("game_member_sign","",C("LEWAN_HEZI"))->where($usergisnArr)->field('sign_num')->find();
                $signNum = !empty($usergisnInfo) ? $usergisnInfo['sign_num'] : 0;

                //发送模板消息
                $posturl 	= "https://api.weixin.qq.com/cgi-bin/message/wxopen/template/send?access_token=".$token;
                $postArr = array(
                    'touser'=>$val['openid']
                    ,'template_id'=>'2BMA-KE2gxmSacPVqCw5q9-gapSo737WuDHTZDdlCiU'
                    ,'page'=>'pages/index/index'
                    ,'form_id'=>$val['form_id']
                    ,'data'=>array(
                        'keyword1'=>array('value'=>"【签到提醒】签到领玩币，玩币当钱花！！！")
                        ,'keyword2'=>array('value'=>"你已连续签到{$signNum}天")
                        ,'keyword3'=>array('value'=>'从微信顶部[任务栏]-我玩过的/我的小程序，进入可领双倍奖励哦~')
                    )
                    // ,'emphasis_keyword'=>"keyword1.DATA"
                );
                $this->curlPost($posturl,json_encode($postArr),true);

                //记录发送数据
                $tupdateArr = array(
                    'status'=>2
                    ,'use_way'=>'sign_tips'
                    ,'send_time'=>date('Y-m-d H:i:s')
                );
                M("yl_template_formid","",C("LEWAN_HEZI"))->where(array('sysid'=>$val['sysid']))->save($tupdateArr);
                
            }
            echo '每日签到提醒发送成功';
        } else {
            echo '每日签到提醒发送完毕';
        }
    }


    //竞拍活动开始提醒
    public function  auctionTips($goodsId='',$name='',$time='') {
        // $goodsId = I('goods_id');
        // $time = I('time');
        if(empty($goodsId) || empty($time)) {
            return '参数不完整';
        }
        $enrollModel = M("game_auction_enroll","",C("LEWAN_HEZI"));
        $enrollWhere = array(
            'remind'=>1
            ,'send_status'=>1
            ,'goods_id'=>$goodsId
        );
        $enrollArr = $enrollModel->where($enrollWhere)->field('uid')->limit(400)->select();
        if(!empty($enrollArr)) {
            $uidArr = array_column($enrollArr,'uid');
            $userWhere = array(
                'status'=>1
                ,'uid'=>array('in',$uidArr)
                ,'add_time'=>array('gt',date('Y-m-d',time()-(60*60*24*6)))
            );
            $userArr = M("yl_template_formid","",C("LEWAN_HEZI"))->where($userWhere)->group('uid')->order('add_time')->limit(400)->select();
            if(!empty($userArr)) {
                $token = $this->getToekn();
                $token = json_decode($token,true)['access_token'];
                foreach($userArr as $key=>$val) {
                    //发送模板消息
                    $posturl 	= "https://api.weixin.qq.com/cgi-bin/message/wxopen/template/send?access_token=".$token;
                    $postArr = array(
                        'touser'=>$val['openid']
                        ,'template_id'=>'bnIZwuwovElUz0aCDxRS_AVtM1JsGVMLgjEsY_8XtEQ'
                        ,'page'=>'/pages/index/index?goPath=/pages/auctionDetail/auctionDetailQUESTIONgoodsIdEQUAL'.$goodsId.'ANDfromEQUALapp'
                        ,'form_id'=>$val['form_id']
                        ,'data'=>array(
                            'keyword1'=>array('value'=>"您预约的{$name}免费竞拍活动快要开始啦")
                            ,'keyword2'=>array('value'=>$time)
                            ,'keyword3'=>array('value'=>'邀请好友可以增加出价次数，出价次数越多，商品越容易竞拍成功哦~')
                        )
                        // ,'emphasis_keyword'=>"keyword1.DATA"
                    );
                    $this->curlPost($posturl,json_encode($postArr),true);

                    //记录发送数据
                    $enrollModel->startTrans();
                    $re1 = $enrollModel->where(array('uid'=>$val['uid'],'goods_id'=>$goodsId))->save(array('send_status'=>2,'send_time'=>date('Y-m-d H:i:s')));

                    $tupdateArr = array(
                        'status'=>2
                        ,'use_way'=>'auction_tips'
                        ,'send_time'=>date('Y-m-d H:i:s')
                    );
                    $re2 = M("yl_template_formid","",C("LEWAN_HEZI"))->where(array('sysid'=>$val['sysid']))->save($tupdateArr);
                    if($re1 && $re2) {
                        $enrollModel->commit();
                    }
                    
                }
            }
            return '竞拍活动开始提醒发送成功';
        }
        return '竞拍活动开始提醒发送完毕';
    }


    //竞拍获胜通知
    public function  auctionWin($auctionArr) {
        // $auctionArr = $_POST;
        // $auctionArr = json_decode($auction_info,true);
        // var_dump($auctionArr['end_time']);exit;

        if(empty($auctionArr['bid_uid']) || empty($auctionArr['end_time']) || empty($auctionArr['bid_price'])) {
			return '参数不完整';
        }
        
        $model = M("yl_template_formid","",C("LEWAN_HEZI"));
        $userWhere = array(
            'status'=>1
            ,'uid'=>$auctionArr['bid_uid']
            ,'add_time'=>array('gt',date('Y-m-d',time()-(60*60*24*6)))
        );
        $userArr = $model->where($userWhere)->order('add_time')->find();
        if(!empty($userArr)) {
            $token = $this->getToekn();
            $token = json_decode($token,true)['access_token'];

            //发送模板消息
            $posturl 	= "https://api.weixin.qq.com/cgi-bin/message/wxopen/template/send?access_token=".$token;
            $postArr = array(
                'touser'=>$userArr['openid']
                ,'template_id'=>'TFdwfj6A6RH42aLYjnpcyEUBn3XUkQtZ9e0LvZEdqM0'
                ,'page'=>'/pages/index/index?goPath=/pages/auctionDetail/auctionDetailQUESTIONgoodsIdEQUAL'.$auctionArr['id'].'ANDfromEQUALapp'
                ,'form_id'=>$userArr['form_id']
                ,'data'=>array(
                    'keyword1'=>array('value'=>$auctionArr['name'])
                    ,'keyword2'=>array('value'=>$auctionArr['end_time'])
                    ,'keyword3'=>array('value'=>$auctionArr['bid_price'].'玩币')
                    ,'keyword4'=>array('value'=>'竞拍成功的商品，请注意在页面完成商品领取哦~')
                )
                // ,'emphasis_keyword'=>"keyword1.DATA"
            );
            $this->curlPost($posturl,json_encode($postArr),true);
            $updateArr = array(
                'status'=>2
                ,'use_way'=>'auction_win'
                ,'send_time'=>date('Y-m-d H:i:s')
            );
            $model->where(array('sysid'=>$userArr['sysid']))->save($updateArr);
            return '竞拍获胜通知发送成功';
        }

        return 'formid已使用完毕';
    }

    public function getToekn()
    {
        $filepath = 'http://ylc.test.llewan.com/wechat/retToekn';
        $token = file_get_contents($filepath);
        return $token;
    }

    public function retToekn() {
        $filepath = 'uploadfile/wechatToken.txt';
        $url = 'https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid='.$this->appid.'&secret='.$this->secret;
        //检查access_token是否过期
        if(file_exists($filepath)) {
            $fileTime = filemtime($filepath);
            if(($fileTime+7000) < time()) {
                $token = file_get_contents($url);
                file_put_contents($filepath,$token);
            } else {
                $token = file_get_contents($filepath);
            }
        } else {
            $token = file_get_contents($url);
            file_put_contents($filepath,$token);
        }
        $token = file_get_contents($filepath);
        echo $token;
    }
    
    protected function curlPost($url,$data='',$is_ssl = false) {
        $ch = curl_init();
        // 配置
        curl_setopt($ch, CURLOPT_URL,$url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
        if ($is_ssl) {
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0); // 对认证证书来源的检查
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2); // 从证书中检查SSL加密算法是否存在
            curl_setopt($ch, CURLOPT_SSLVERSION, 1); // 设定SSL版本,微信时候使用1，否则报错
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        }
    
        // 执行
        $re = curl_exec($ch);
    
        // 关闭
        curl_close($ch);
        return $re;
    }
    
    protected function valid() {
        $echoStr = $_GET["echostr"];
        if($this->checkSignature()){
            header('content-type:text');
            echo $echoStr;
            exit;
        }
    }
    
    protected function checkSignature() {
        $signature = isset($_GET["signature"]) ? $_GET["signature"] : '';
        $timestamp = isset($_GET["timestamp"]) ? $_GET["timestamp"] : '';
        $nonce = isset($_GET["nonce"]) ? $_GET["nonce"] : '';
    
        $token = 'lewan';
        $tmpArr = array($token, $timestamp, $nonce);
        sort($tmpArr, SORT_STRING);
        $tmpStr = implode( $tmpArr );
        $tmpStr = sha1( $tmpStr );
    
        if( $tmpStr == $signature ){
            return true;
        }else{
            return false;
        }
    }

}

?>