<?php
namespace Home\Controller;
use Think\Controller;
/*
* 进入应用控制器
*
*/
class AuctionController extends BaseController
{
	//倒计时
	public $countdown = 150;

	//竞拍商品列表
	public $goodsList = array(
		array(
			'date'=>'2018-09-21'
			,'name'=>'一期竞拍'
			,'list'=> array(
				array(
						'id'=>'hezijp001'
						,'name'=>'【抖音爆款】会唱歌的妖娆花'
						,'icon'=>'auction/1/icon.jpg'
						,'cover'=>'auction/1/head.jpg'
						,'desc'=>array(
							'auction/1/desc1.jpg'
							,'auction/1/desc2.jpg'
							,'auction/1/desc3.jpg'
							,'auction/1/desc4.jpg'
							,'auction/1/desc5.jpg'
							,'auction/1/desc6.jpg'
							,'auction/1/desc7.jpg'
						)
						,'original_price'=>168
						,'range_price'=>10
						,'initial_price'=>50
						,'bid_price'=>50
						,'enroll_price'=>50
						,'start_time'=>'2018-09-21 17:00'
						,'end_time'=>''
						,'status'=>'1'
				)
			)
		)
		// ,array(
		// 	'date'=>'2018-09-22'
		// 	,'name'=>'一期竞拍'
		// 	,'list'=> array(
		// 		array(
		// 			'id'=>'hezijp002'
		// 			,'name'=>'【妈妈最爱】BB锅'
		// 			,'icon'=>'auction/2/icon.jpg'
		// 			,'cover'=>'auction/2/head.jpg'
		// 			,'desc'=>array(
		// 				'auction/2/desc1.jpg'
		// 				,'auction/2/desc2.jpg'
		// 				,'auction/2/desc3.jpg'
		// 				,'auction/2/desc4.jpg'
		// 			)
		// 			,'original_price'=>188
		// 			,'range_price'=>10
		// 			,'initial_price'=>80
		// 			,'bid_price'=>80
		// 			,'enroll_price'=>50
		// 			,'start_time'=>'2018-09-22 16:48'
		// 			,'end_time'=>''
		// 			,'status'=>'1'
		// 		)
		// 		,array(
		// 			'id'=>'hezijp003'
		// 			,'name'=>'【爱的牵引】防走失背包'
		// 			,'icon'=>'auction/3/icon.jpg'
		// 			,'cover'=>'auction/3/head.jpg'
		// 			,'desc'=>array(
		// 				'auction/3/desc1.jpg'
		// 				,'auction/3/desc2.jpg'
		// 				,'auction/3/desc3.jpg'
		// 				,'auction/3/desc4.jpg'
		// 				,'auction/3/desc5.jpg'
		// 			)
		// 			,'original_price'=>186
		// 			,'range_price'=>10
		// 			,'initial_price'=>100
		// 			,'bid_price'=>100
		// 			,'enroll_price'=>50
		// 			,'start_time'=>'2018-09-22 17:00'
		// 			,'end_time'=>''
		// 			,'status'=>'1'
		// 		)
		// 	)
		// )
		,array(
			'date'=>'2018-09-23'
			,'name'=>'二期竞拍'
			,'list'=> array(
					array(
						'id'=>'hezijp010'
						,'name'=>'【抖音爆款】会唱歌的妖娆花'
						,'icon'=>'auction/1/icon.jpg'
						,'cover'=>'auction/1/head.jpg'
						,'desc'=>array(
							'auction/1/desc1.jpg'
							,'auction/1/desc2.jpg'
							,'auction/1/desc3.jpg'
							,'auction/1/desc4.jpg'
							,'auction/1/desc5.jpg'
							,'auction/1/desc6.jpg'
							,'auction/1/desc7.jpg'
						)
						,'original_price'=>168
						,'range_price'=>10
						,'initial_price'=>50
						,'bid_price'=>50
						,'enroll_price'=>50
						,'start_time'=>'2018-09-23 12:30'
						,'end_time'=>''
						,'status'=>'1'
				)
				,array(
					'id'=>'hezijp003'
					,'name'=>'【爱的牵引】防走失背包'
					,'icon'=>'auction/3/icon.jpg'
					,'cover'=>'auction/3/head.jpg'
					,'desc'=>array(
						'auction/3/desc1.jpg'
						,'auction/3/desc2.jpg'
						,'auction/3/desc3.jpg'
						,'auction/3/desc4.jpg'
						,'auction/3/desc5.jpg'
					)
					,'original_price'=>186
					,'range_price'=>10
					,'initial_price'=>100
					,'bid_price'=>100
					,'enroll_price'=>50
					,'start_time'=>'2018-09-23 16:00'
					,'end_time'=>''
					,'status'=>'1'
				)
				,array(
					'id'=>'hezijp007'
					,'name'=>'【抖音同款】不会倒的蜘蛛侠'
					,'icon'=>'auction/7/icon.jpg'
					,'cover'=>'auction/7/head.jpg'
					,'desc'=>array(
						'auction/7/desc1.jpg'
						,'auction/7/desc2.jpg'
						,'auction/7/desc3.jpg'
						,'auction/7/desc4.jpg'
						,'auction/7/desc5.jpg'
						,'auction/7/desc6.jpg'
					)
					,'original_price'=>228
					,'range_price'=>10
					,'initial_price'=>80
					,'bid_price'=>80
					,'enroll_price'=>50
					,'start_time'=>'2018-09-23 20:30'
					,'end_time'=>''
					,'status'=>'1'
				)
				,array(
					'id'=>'hezijp002'
					,'name'=>'【妈妈最爱】BB锅'
					,'icon'=>'auction/2/icon.jpg'
					,'cover'=>'auction/2/head.jpg'
					,'desc'=>array(
						'auction/2/desc1.jpg'
						,'auction/2/desc2.jpg'
						,'auction/2/desc3.jpg'
						,'auction/2/desc4.jpg'
					)
					,'original_price'=>188
					,'range_price'=>10
					,'initial_price'=>80
					,'bid_price'=>80
					,'enroll_price'=>50
					,'start_time'=>'2018-09-23 22:00'
					,'end_time'=>''
					,'status'=>'1'
				)
				// ,array(
				// 	'id'=>'hezijp004'
				// 	,'name'=>'【明星同款】会学人说话的火烈鸟'
				// 	,'icon'=>'auction/4/icon.jpg'
				// 	,'cover'=>'auction/4/head.jpg'
				// 	,'desc'=>array(
				// 		'auction/4/desc1.jpg'
				// 		,'auction/4/desc2.jpg'
				// 		,'auction/4/desc3.jpg'
				// 		,'auction/4/desc4.jpg'
				// 		,'auction/4/desc5.jpg'
				// 	)
				// 	,'original_price'=>108
				// 	,'range_price'=>10
				// 	,'initial_price'=>100
				// 	,'bid_price'=>100
				// 	,'enroll_price'=>50
				// 	,'start_time'=>'2018-09-23 12:30'
				// 	,'end_time'=>''
				// 	,'status'=>'1'
				// )
				// ,array(
				// 	'id'=>'hezijp005'
				// 	,'name'=>'【陪玩神器】面包超人跳跳球'
				// 	,'icon'=>'auction/5/icon.jpg'
				// 	,'cover'=>'auction/5/head.jpg'
				// 	,'desc'=>array(
				// 		'auction/5/desc1.jpg'
				// 		,'auction/5/desc2.jpg'
				// 		,'auction/5/desc3.jpg'
				// 	)
				// 	,'original_price'=>116
				// 	,'range_price'=>10
				// 	,'initial_price'=>60
				// 	,'bid_price'=>60
				// 	,'enroll_price'=>50
				// 	,'start_time'=>'2018-09-23 20:30'
				// 	,'end_time'=>''
				// 	,'status'=>'1'
				// )
				// ,array(
				// 	'id'=>'hezijp006'
				// 	,'name'=>'【童年回忆】mini游戏掌机'
				// 	,'icon'=>'auction/6/icon.jpg'
				// 	,'cover'=>'auction/6/head.jpg'
				// 	,'desc'=>array(
				// 		'auction/6/desc1.jpg'
				// 		,'auction/6/desc2.jpg'
				// 		,'auction/6/desc3.jpg'
				// 		,'auction/6/desc4.jpg'
				// 		,'auction/6/desc5.jpg'
				// 	)
				// 	,'original_price'=>199
				// 	,'range_price'=>10
				// 	,'initial_price'=>150
				// 	,'bid_price'=>150
				// 	,'enroll_price'=>50
				// 	,'start_time'=>'2018-09-23 21:00'
				// 	,'end_time'=>''
				// 	,'status'=>'1'
				// )
			)
		)
		,array(
			'date'=>'2018-09-24'
			,'name'=>'三期竞拍'
			,'list'=> array(
				array(
					'id'=>'hezijp004'
					,'name'=>'【明星同款】会学人说话的火烈鸟'
					,'icon'=>'auction/4/icon.jpg'
					,'cover'=>'auction/4/head.jpg'
					,'desc'=>array(
						'auction/4/desc1.jpg'
						,'auction/4/desc2.jpg'
						,'auction/4/desc3.jpg'
						,'auction/4/desc4.jpg'
						,'auction/4/desc5.jpg'
					)
					,'original_price'=>108
					,'range_price'=>10
					,'initial_price'=>100
					,'bid_price'=>100
					,'enroll_price'=>50
					,'start_time'=>'2018-09-24 12:30'
					,'end_time'=>''
					,'status'=>'1'
				)
				,array(
					'id'=>'hezijp005'
					,'name'=>'【陪玩神器】面包超人跳跳球'
					,'icon'=>'auction/5/icon.jpg'
					,'cover'=>'auction/5/head.jpg'
					,'desc'=>array(
						'auction/5/desc1.jpg'
						,'auction/5/desc2.jpg'
						,'auction/5/desc3.jpg'
					)
					,'original_price'=>116
					,'range_price'=>10
					,'initial_price'=>60
					,'bid_price'=>60
					,'enroll_price'=>50
					,'start_time'=>'2018-09-24 16:00'
					,'end_time'=>''
					,'status'=>'1'
				)
				,array(
					'id'=>'hezijp008'
					,'name'=>'【贴心神器】三合一加湿器'
					,'icon'=>'auction/9/icon.jpg'
					,'cover'=>'auction/9/head.jpg'
					,'desc'=>array(
						'auction/9/desc1.jpg'
						,'auction/9/desc2.jpg'
						,'auction/9/desc3.jpg'
						,'auction/9/desc4.jpg'
						,'auction/9/desc5.jpg'
					)
					,'original_price'=>128
					,'range_price'=>10
					,'initial_price'=>80
					,'bid_price'=>80
					,'enroll_price'=>50
					,'start_time'=>'2018-09-24 20:30'
					,'end_time'=>''
					,'status'=>'1'
				)
				,array(
					'id'=>'hezijp009'
					,'name'=>'【治愈小象】会说话的大象'
					,'icon'=>'auction/8/icon.jpg'
					,'cover'=>'auction/8/head.jpg'
					,'desc'=>array(
						'auction/8/desc1.jpg'
						,'auction/8/desc2.jpg'
						,'auction/8/desc3.jpg'
						,'auction/8/desc4.jpg'
					)
					,'original_price'=>308
					,'range_price'=>10
					,'initial_price'=>200
					,'bid_price'=>200
					,'enroll_price'=>50
					,'start_time'=>'2018-09-24 22:00'
					,'end_time'=>''
					,'status'=>'1'
				)
			)
		)
	);

	private function init_redis() {
		//连接本地的 Redis 服务
		$redis = new Redis();
		$redis->connect('127.0.0.1', 6379);
		return $redis;
	}

	//竞拍商品列表接口
	public function goodsList(){
		//竞拍商品列表
		$goodsList = $this->goodsList;
		//获取竞拍商品信息
		$redis = S(C('REDIS'));
		$leftArray = array();
		$rightArray = array();
		foreach($goodsList as $key=>$val) {

			$lleftArray = array();
			$lrightArray = array();
			foreach($val['list'] as $lkey=>$lval) {
				$goodsInfo = $redis->get($lval['id']);
				// $goodsInfo = json_decode($goodsJson, true);

				//判断是否到竞拍时间
				$tempStartTime = strtotime($lval['start_time']);
				if($tempStartTime <= time()) {
					$lval['status'] = 2;
				}
				if(empty($lval['bid_total'])) {
					$lval['bid_total'] = 0;
				}

				if(!empty($goodsInfo) && $goodsInfo['status'] > 1) {
					//竞拍结束处理
					if( $goodsInfo['status'] < 3) {
						if(empty($goodsInfo['bid_time']) && (strtotime($goodsInfo['start_time'])+600) <= time()) {
							//没用户参与，十分钟自动结束
							$goodsInfo['status'] = 3;
							$goodsInfo['end_time'] = date('Y-m-d H:i');
							$goodsJson = json_encode($goodsInfo);
							$redis->set($goodsInfo['id'],$goodsJson);
						} else if(!empty($goodsInfo['bid_time']) && (intval(strtotime($goodsInfo['bid_time']))+$this->countdown) <= time()) {
							//竞拍胜出
							$model= new \Home\Model\AuctionModel();
							$goodsInfo = $model->awardSave($goodsInfo);

							$wechatObj = new \Home\Controller\WechatController();
							$wechatObj->auctionWin($goodsInfo);
							// $eee = curlPost(C('domain').'wechat/auctionWin',$goodsInfo);
						} else {
							//没有用户参与报名竞拍
							// $enrollNum = $GLOBALS["conn"]->NumRows($GLOBALS["conn"]->Query("select sysid from ".get_table("game_auction_enroll")." where game_code='hezi' and goods_id='".$goodsInfo['id']."'"));
                            $enrollNum = M("game_auction_enroll","",C("LEWAN_HEZI"))->where(array('game_code'=>'zuiqiangyoulechang','goods_id'=>$goodsInfo['id']))->count();
                            if($enrollNum < 1) {
								//没有用户报名竞拍，更新redis商品竞拍状态
								$goodsInfo['status'] = 3;
								$goodsInfo['end_time'] = date('Y-m-d H:i');
								$goodsJson = json_encode($goodsInfo);
								$redis->set($goodsInfo['id'],$goodsJson);
							}
						}
					}
					$goodsList[$key]['list'][$lkey] = $goodsInfo;
					$lval = $goodsInfo;
				} else {
					$goodsList[$key]['list'][$lkey] = $lval;
					$redis->set($lval['id'],json_encode($lval));

					//距离十分钟竞拍活动提醒
					if($tempStartTime <= (time()+600)) {
						$wechatObj = new \Home\Controller\WechatController();
						$wechatObj->auctionTips($lval['id'],$lval['name'],$lval['start_time']);
						// curlPost(C('domain').'wechat/auctionTips',array('goods_id'=>$lval['id'],'time'=>$lval['start_time']));
					}
				}
				//$lmid = strtotime($lval['start_time'])-time(); //获取一个用于分割的关键字，一般是首个元素

				$lval['icon'] = C('img_path').$lval['icon'];
				$lval['cover'] = C('img_path').$lval['cover'];

				if($goodsInfo['status'] > 2) {
					$lrightArray[] = $lval;
				} else {
					$lleftArray[] = $lval;
				}
				$goodsList[$key]['list'] = array_merge($lleftArray,$lrightArray); //组合两个结果
			}
			$mid = strtotime($val['date'])-strtotime(date('Y-m-d')); //获取一个用于分割的关键字，一般是首个元素
			if($mid >= 0) {
				if($mid == 0) {
					$goodsList[$key]['name'] = '今天竞拍';
				} else {
					$goodsList[$key]['name'] = '竞拍预告';
				}
				$leftArray[] = $goodsList[$key];
			} else {
				$goodsList[$key]['name'] = '往期竞拍';
				$rightArray[] = $goodsList[$key];
			}
		}
		$goodsList = array_merge($leftArray,$rightArray); //组合两个结果
		if($goodsList[0]['name'] == '竞拍预告') {
			$goodsList[0]['name'] = '最新竞拍';
		}

		$result = array(
			'c'=>1
			,'msg'=>'获取成功'
			,'d'		=> array(
				'list' => $goodsList,
				'activity_date' => '2018.09.21-2018.09.24'
			)
		);
		echo $this->formatRes($result);
	}


	//竞拍商品详情接口
	public function goodsInfo(){
		$token = decryptToken(I('token'));
		$goodsId = I('goods_id');
		

		if($token == false) {
            $result = array(
                'c'=>2
                ,'msg'=>'token不正确'
			);
			echo $this->formatRes($result);exit;
		} else if(empty($goodsId)) {
            $result = array(
                'c'=>2
                ,'msg'=>'goods_id参数不存在'
			);
			echo $this->formatRes($result);exit;
		}
		
		//获取竞拍商品信息
		$goodsInfo = S(C('REDIS'))->get($goodsId);
		if(empty($goodsInfo)) {
            $result = array(
                'c'=>2
                ,'msg'=>'goods_id参数错误'
			);
			echo $this->formatRes($result);exit;
		}

		$uid = $token['uid'];

		//获取竞拍用户报名信息
		$userArr = array(
			'uid'=>$uid
			,'bid_price'=>''
			,'bid_num'=>0
			,'bid_total'=>0
			,'status'=>1
		);
		$enrollNum = 0;

        $userList = M("game_auction_enroll","",C("LEWAN_HEZI"))->where(array('game_code'=>'zuiqiangyoulechang','goods_id'=>$goodsId))->field('uid,bid_price,bid_num,bid_total')->select();
        foreach($userList as $key=>$value) {
            if($value['uid'] == $uid) {
				$userArr = $value;
				$userArr['status'] = 2;
			}
			$enrollNum++;
        }
		//报名人数
		$goodsInfo['enroll_num'] = $enrollNum;

		//获取用户金币信息数据
        $goldrArr = M("game_member","",C("LEWAN_HEZI"))->where(array('uid'=>$uid))->field('uid,gold,user_nickname')->find();
		$userArr['gold'] = $goldrArr['gold']-$userArr['bid_price'];

		//用户奖品领取状态
		$userArr['auction_status'] = 0;
		$userArr['receive_status'] = 0;
		if($goodsInfo['bid_uid'] == $uid) {
			$userArr['auction_status'] = 1;
			//竞拍获奖用户信息数据
            $awardArr = M("game_auction_award","",C("LEWAN_HEZI"))->where(array('uid'=>$uid,'game_code'=>'zuiqiangyoulechang','goods_id'=>$goodsInfo['id']))->field('uid,receive_status')->find();
			if(!empty($awardArr)) {
				$userArr['receive_status'] = $awardArr['receive_status'];
			}
		}

		$goodsInfo['icon'] = C('img_path').$goodsInfo['icon'];
		$goodsInfo['cover'] = C('img_path').$goodsInfo['cover'];
		foreach($goodsInfo['desc'] as $dkey=>$dval) {
			$goodsInfo['desc'][$dkey] = C('img_path').$dval;
		}

		$result = array(
			'c'=>1
			,'msg'=>'获取成功'
			,'d'	=> array(
				'auction_info' => $goodsInfo
				,'user_info' => $userArr
				,'countdown' => $this->countdown
				,'time' => time().'000'
			)
		);
		echo $this->formatRes($result);
	}

	//用户竞拍报名
	public function userEnroll(){
		$token = decryptToken(I('token'));
		$goodsId = I('goods_id');
		$remind = I('remind',1);

		if($token == false) {
            $result = array(
                'c'=>2
                ,'msg'=>'token不正确'
			);
			echo $this->formatRes($result);exit;
		} else if(empty($goodsId)) {
            $result = array(
                'c'=>2
                ,'msg'=>'goods_id参数不存在'
			);
			echo $this->formatRes($result);exit;
		}
		
		//获取竞拍商品信息
		$goodsInfo = S(C('REDIS'))->get($goodsId);
		if(empty($goodsInfo)) {
            $result = array(
                'c'=>2
                ,'msg'=>'goods_id参数错误'
			);
			echo $this->formatRes($result);exit;
		}

		//获取竞拍商品信息
		if($goodsInfo['status'] > 1) {
			$result = array(
                'c'=>2
                ,'msg'=>'报名已截至'
			);
			echo $this->formatRes($result);exit;
		}

		$uid = $token['uid'];
		$num = M("game_auction_enroll","",C("LEWAN_HEZI"))->where(array('game_code'=>'zuiqiangyoulechang','uid'=>$uid,'goods_id'=>$goodsId))->count();
		if($num > 0) {
			$result = array(
                'c'=>2
                ,'msg'=>'已报名'
			);
			echo $this->formatRes($result);exit;
		}

		//保存报名信息
		$model= new \Home\Model\AuctionModel();
		$result = $model->enrollSave($uid,$goodsId,$remind,$goodsInfo['enroll_price']);

		echo $this->formatRes($result);exit;
	}

	//竞拍商品出价接口
	public function userBid()
	{

		$token = decryptToken(I('token'));
		$goodsId = I('goods_id');
		$price = I('price');

		if($token == false) {
            $result = array(
                'c'=>2
                ,'msg'=>'token不正确'
			);
			echo $this->formatRes($result);exit;
		} else if(empty($goodsId)) {
            $result = array(
                'c'=>2
                ,'msg'=>'goods_id参数不存在'
			);
			echo $this->formatRes($result);exit;
		} else if(empty($price)) {
            $result = array(
                'c'=>2
                ,'msg'=>'price参数不存在'
			);
			echo $this->formatRes($result);exit;
		}
		
		//获取竞拍商品信息
		$goodsInfo = S(C('REDIS'))->get($goodsId);
		if(empty($goodsInfo)) {
            $result = array(
                'c'=>2
                ,'msg'=>'goods_id参数错误'
			);
			echo $this->formatRes($result);exit;
		}

		$uid = $token['uid'];

		//判断竞拍商品状态
		if($goodsInfo['status'] == 1 && strtotime($goodsInfo['start_time']) > time()) {
			$result = array(
                'c'=>2
                ,'msg'=>'竞拍还没开始'
			);
		} else if($goodsInfo['status'] == 3) {
			$result = array(
                'c'=>2
                ,'msg'=>'竞拍已结束开始'
			);
		} else {

			//判断是否已是出价最高用户
			if($goodsInfo['bid_uid'] == $uid) {
				$result = array(
					'c'=>2
					,'msg'=>'已是出价最高用户'
				);
				echo $this->formatRes($result);exit;
			} else if($goodsInfo['bid_price'] >= $price) {
				$result = array(
					'c'=>2
					,'msg'=>'出价低于当前商品竞拍价格'
				);
			} else if(($goodsInfo['bid_price']+$goodsInfo['range_price']) < $price) {
				$result = array(
					'c'=>2
					,'msg'=>'出价高于当前商品竞拍价格范围'
				);
			} else {
				//保存出价信息
				$model= new \Home\Model\AuctionModel();
				$result = $model->bidSave($uid,$goodsId,$price,$goodsInfo);
			}


		}

		echo $this->formatRes($result);exit;
	}

	//获取竞拍中商品详情接口
	public function auctionInfo()
	{
		$goodsId = I('goods_id');

		if(empty($goodsId)) {
            $result = array(
                'c'=>2
                ,'msg'=>'goods_id参数不存在'
			);
			echo $this->formatRes($result);exit;
		}
		
		//获取竞拍商品信息
		$goodsInfo = S(C('REDIS'))->get($goodsId);
		if(empty($goodsInfo)) {
            $result = array(
                'c'=>2
                ,'msg'=>'goods_id参数错误'
			);
		} else {
			$result = array(
                'c'=>1
                ,'msg'=>'获取成功'
                ,'d'=>array(
					'auction_info' => $goodsInfo,
					'time' => time().'000',
				)
			);
		}

		echo $this->formatRes($result);exit;
	}

	//获取用户竞拍列表接口
	public function userAuction()
	{
		$token = decryptToken(I('token'));

		if($token == false) {
            $result = array(
                'c'=>2
                ,'msg'=>'token不正确'
			);
			echo $this->formatRes($result);exit;
		}
		$uid = $token['uid'];

		//获取用户报名参与竞拍
		$auctionArr = M("game_auction_enroll","",C("LEWAN_HEZI"))->where(array('game_code'=>'zuiqiangyoulechang','uid'=>$uid))->order('create_time desc')->select();

		if(!empty($auctionArr)) {
			//获取竞拍商品信息
			foreach($auctionArr as $key=>$val) {
				//获取竞拍商品详情信息
				$goodsInfo = S(C('REDIS'))->get($val['goods_id']);
				$goodsInfo['icon'] = C('img_path').$goodsInfo['icon'];
				$goodsInfo['cover'] = C('img_path').$goodsInfo['cover'];

				$goodsInfo['auction_status'] = 0;//用户竞拍状态 0-竞拍失败 1-竞拍成功
				$goodsInfo['receive_status'] = 0;//奖品领取状态 0-未领取 1-已领取
				if($goodsInfo['bid_uid'] == $uid) {
					$goodsInfo['auction_status'] = 1;
					//竞拍获奖用户信息数据
					$awardWhere = array(
						'uid'=>$uid
						,'game_code'=>'zuiqiangyoulechang'
						,'goods_id'=>$goodsInfo['id']
					);
					$awardArr = M("game_auction_award","",C("LEWAN_HEZI"))->where($awardWhere)->field('uid,receive_status')->find();
					if(!empty($awardArr)) {
						$goodsInfo['receive_status'] = $awardArr['receive_status'];
					}
				}
				$auctionArr[$key] = $goodsInfo;
			}

			$result = array(
				'c'=>1
				,'msg'=>'获取成功'
				,'d'=>array(
					'auction_info' => $auctionArr
				)
			);
		} else {
			$result = array(
                'c'=>2
                ,'msg'=>'没有内容'
			);
		}

		echo $this->formatRes($result);exit;
	}

	//获取用户地址信息
	public function userAddress(){
		$token = decryptToken(I('token'));

		if($token == false) {
            $result = array(
                'c'=>2
                ,'msg'=>'token不正确'
			);
			echo $this->formatRes($result);exit;
		}
		$uid = $token['uid'];

		//获取用户今天做任务数据
		$addressArr = M("game_member_address","",C("LEWAN_HEZI"))->where(array('uid'=>$uid,'game_code'=>'zuiqiangyoulechang'))->find();

		if(!empty($addressArr)) {
			$result = array(
                'c'=>1
				,'msg'=>'获取成功'
				,'d'=> array(
					'consignee'=> $addressArr['consignee']
					,'phone'	=> $addressArr['phone']
					,'address'	=> $addressArr['address']
				)
			);
		} else {
			$result = array(
                'c'=>2
                ,'msg'=>'没有内容'
			);
		}

		echo $this->formatRes($result);exit;
	}

	//保存用户地址信息
	public function saveAddress(){
		$token = decryptToken(I('token'));
		$consignee = I('consignee');
		$phone = I('phone');
		$address = I('address');
		$goods_id = I('goods_id');
		$receive = I('receive');

		if($token == false) {
            $result = array(
                'c'=>2
                ,'msg'=>'token不正确'
			);
			echo $this->formatRes($result);exit;
		} else if(empty($consignee)) {
            $result = array(
                'c'=>2
                ,'msg'=>'consignee参数不存在'
			);
			echo $this->formatRes($result);exit;
		} else if(empty($phone)) {
            $result = array(
                'c'=>2
                ,'msg'=>'phone参数不存在'
			);
			echo $this->formatRes($result);exit;
		} else if(empty($address)) {
            $result = array(
                'c'=>2
                ,'msg'=>'address参数不存在'
			);
			echo $this->formatRes($result);exit;
		}
		
		$uid = $token['uid'];
		$userAddress = M("game_member_address","",C("LEWAN_HEZI"))->where(array('uid'=>$uid,'game_code'=>'zuiqiangyoulechang'))->count();
		if($userAddress > 0) {
			//更新用户地址信息
			$updateArr = array(
				'consignee'=>$consignee
				,'phone'=>$phone
				,'address'=>$address
			);
			M("game_member_address","",C("LEWAN_HEZI"))->where(array('uid'=>$uid,'game_code'=>'zuiqiangyoulechang'))->save($updateArr);
		} else {
			//新增用户地址信息
			$addArr = array(
				'uid'=>$uid
				,'consignee'=>$consignee
				,'phone'=>$phone
				,'address'=>$address
				,'create_time'=>date('Y-m-d H:i:s')
				,'game_code'=>'zuiqiangyoulechang'
			);

			M("game_member_address","",C("LEWAN_HEZI"))->add($addArr);
		}

		if(!empty($goods_id) && !empty($receive)) {
			//更新用户领奖信息
			$updateArr = array(
				'consignee'=>$consignee
				,'phone'=>$phone
				,'address'=>$address
				,'receive_status'=>$receive
			);
			$updateWhere = array(
				'uid'=>$uid
				,'game_code'=>'zuiqiangyoulechang'
				,'goods_id'=>$goods_id
			);
			M("game_auction_award","",C("LEWAN_HEZI"))->where($updateWhere)->save($updateArr);
		}

		$result = array(
			'c'=>1
			,'msg'=>'保存成功'
		);

		echo $this->formatRes($result);exit;
	}

	public function auctionFlush() {
		S(C('REDIS'))->del('hezijp0010');
		S(C('REDIS'))->del('hezijp002');
		S(C('REDIS'))->del('hezijp003');
		S(C('REDIS'))->del('hezijp004');
		S(C('REDIS'))->del('hezijp005');
		S(C('REDIS'))->del('hezijp006');
		S(C('REDIS'))->del('hezijp007');
		S(C('REDIS'))->del('hezijp008');
		S(C('REDIS'))->del('hezijp009');
	}



}

?>